#include "ot4xb.ch"
//-------------------------------------------------------------------------------------------------------------------------
function WildFindWindow( cStr )
local aWnd     := {}
local pParam   := _xgrab(8)
DEFAULT cStr := ""
PokeDWord( pParam,,{_var2con(aWnd),_var2con(cStr)} )
@user32:EnumWindows(_callback_WildFindWindow_EnumProc(),pParam)
aEval( PeekDWord(pParam,,2) , {|e| _conRelease(e) } )
_xfree(pParam)
return aWnd
//-------------------------------------------------------------------------------------------------------------------------
function WildFindWindow_EnumProc( hWnd , pParam )
local aInfo     := Array(5)
local n         := @user32:GetWindowTextLengthA(hWnd)
local cStr      := _con2var(PeekDWord(pParam,4))
local c                                         
c := ChrR(0,n)
@user32:GetWindowTextA(hWnd,@c,Len(c)+1)
if ( iif(n == 0,Empty(cStr), cStr $ c) )
   aInfo[1] := hWnd
   aInfo[2] := c
   n := 0
   aInfo[3] := @user32:GetWindowThreadProcessId(hWnd,@n)
   aInfo[4] := n
   c := ChrR(0,260)
   aInfo[5] := cPid2ModName(aInfo[4] )
   aadd( _con2var(PeekDWord(pParam)) , aInfo )
end
return .T.
//-------------------------------------------------------------------------------------------------------------------------
static function cPid2ModName( nPid )
local hProcess := @kernel32:OpenProcess(0x410,.F.,nPid)
local cName    := Chrr(0,512)
local hMod     := 0
local cbn      := 0
if( !Empty(hProcess) )
   if( @psapi:EnumProcessModules(hProcess,@hMod,4,@cbn) != 0 )
      @psapi:GetModuleBaseNameA(hProcess,hMod,@cName, Len(cName))
   end
   @kernel32:CloseHandle(hProcess)
end
return TrimZ(cName)
